<template>
  <base-popup class="auth-modal">
    <div id="authForm" class="auth-modal-body">
      <div id="list-tab" class="nav auth-modal-head" role="tablist">
        <a
          v-for="tab in tabs.slice(0, 2)"
          :key="tab.key"
          href="#"
          :class="{ active: currentTab === tab.key }"
          @click.prevent="currentTab = tab.key"
          >{{ tab.name }}</a
        >
      </div>
      <div id="nav-tabContent" class="tab-list">
        <transition name="faded" mode="out-in">
          <component
            :is="currentTab"
            ref="form"
            @submit="onSubmit"
            @recovery="currentTab = 'recovery'"
          />
        </transition>
      </div>
    </div>
  </base-popup>
</template>

<script>
import { mapMutations } from 'vuex'
import { TypesPopup } from '@/constants/store.types'

const FormLogin = () => import('@/components/forms/FormLogin.vue')
const FormRegister = () => import('@/components/forms/FormRegister.vue')
const FormRecover = () => import('@/components/forms/FormRecover.vue')

export default {
  components: {
    login: FormLogin,
    register: FormRegister,
    recovery: FormRecover,
  },
  /**
   * @typedef Data
   * @property {'register'|'login'|'recovery'} currentTab
   * @property {(controls: any) => void} login
   * @property {(controls: any) => void} register
   * @property {(controls: any) => void} recovery
   */
  data() {
    const tabs = [
      { key: 'login', name: 'Вход' },
      { key: 'register', name: 'Регистрация' },
      { key: 'recovery', name: 'Восстановление' },
    ]
    return {
      tabs,
      currentTab: tabs[0].key,
    }
  },
  methods: {
    ...mapMutations({
      closePopup: TypesPopup.mutations.CLOSE_POPUP,
    }),
    toastMail() {
      this.$toast.info('Проверьте свою почту...', {
        duration: 3000,
        iconPack: 'custom-class',
        icon: 'icon-mail',
        className: 'toast-email-verification',
      })
    },
    register(controls) {
      this.$store.dispatch('authService/register', controls).then(() => {
        this.$refs.form.reset()
        this.toastMail()
      })
    },
    login(controls) {
      this.$store.dispatch('authService/login', controls).then(() => {
        this.$refs.form.reset()
        this.closePopup()
      })
    },
    recovery(controls) {
      this.$store.dispatch('authService/recover', controls).then(() => {
        this.$refs.form.reset()
        this.toastMail()
      })
    },
    /**
     * @this {Data}
     * @param {any} controls
     */
    onSubmit(controls) {
      this[this.currentTab](controls)
    },
  },
}
</script>

<style lang="less" scoped>
.faded-enter-active,
.faded-leave-active {
  transition: opacity 0.5s;
}
.faded-enter, .faded-leave-to /* .fade-leave-active до версии 2.1.8 */ {
  opacity: 0;
}
</style>
